// VisSamples.h
//
// Copyright  1999-2000 Microsoft Corporation, All Rights Reserved
//

// LATER:  Might want to use TCHAR instead of char.


// Function for find the directory containing sample images.
inline int VisGetSampleDirPath(char *szPath,
		bool fIncludeBackslash = false)
{
	const char *szThisFile = __FILE__;
	assert(szThisFile != 0);

	// Find the last backslash in the path for this file.
	const char *pchLastPathSep = strrchr(szThisFile, '\\');
	assert(pchLastPathSep != 0);
	assert(*pchLastPathSep == '\\');

	int cchPath = pchLastPathSep - szThisFile;
	if (fIncludeBackslash)
		++ cchPath;

	if (szPath != 0)
	{
		// Copy the path.
		strncpy(szPath, szThisFile, cchPath);
		szPath[cchPath] = 0;
	}

	return cchPath;
}


// Function to get the full path for a specified sample image.
// This just appends the name of the sample image to the path
// to the samples directory.
// (Returns the number of characters in the full path.)
inline int VisGetFullPathForSample(char *szFullPath, const char *szSample)
{
	// UNDONE:  If the sample dir path does not exist (probably because
	// we're running on a different machine), assume that the sample
	// files are in the save directory as the program.
	int cch = VisGetSampleDirPath(szFullPath, true);

	if ((szFullPath != 0) && (szSample != 0))
	{
		// Append the file name to the path.
		strcpy(szFullPath + cch, szSample);
	}

	if (szSample != 0)
		cch += strlen(szSample);

	return cch;
}

